//Handles research and technology

function Armory()
{
  this.weapons = [];
  this.step = 0;
  this.pick = function()  //Picks a weapon from availables
  {
    this.step++;
    if(!(this.step < this.weapons.length))
    {
      this.step = 0;
    }
    return this.weapons[this.step];
  };
  
  this.reset = function()
  {
    this.weapons = [];
  };
  
  this.check = function(w, c) //Check what weapons or structures are availabe. c must be true if testing for a weapon or false for structures.
  {
    if(w)
    {
      for(var a = 0; a < w.length; a++)
      {
        for(var b = 0; b < w[a].length; b++)
        {
          if(c)
          {
            if(componentAvailable(w[a][b]))
            {
			  if(w[a][b] == "PlasmaHeavy") //PlasmaHeavy workaround.
              {
				if(storage.PlasmaHeavyBug)
				{
			      this.weapons.push(w[a]);
			    }
			  }else
		      {
				this.weapons.push(w[a]);
		      }
            }
          }
          else
          {
             if(isStructureAvailable(w[a][b]))
             {
               this.weapons.push(w[a]);
             }
          }
        }
      }
    }
  };
}

//--------------------------------------------------------------------------
// Set strings array to be researched.
//--------------------------------------------------------------------------
function setResearch()
{ 
  var techRes = getTechTree(storage.personality);
  techRes[0] = techRes[0].concat(
    [
      "R-Defense-Tower01", //Machine gun metal tower
      "R-Wpn-MG-Damage04",
      "+R-Wpn-Mortar01Lt",
      "+R-Wpn-Mortar-Damage01",
      "+R-Struc-PowerModuleMk1", //Power Module
      "+R-Struc-Research-Module", //Research Module
      "+R-Struc-Factory-Module", //Factory Module
      "+R-Defense-WallTower01"
    ]);
  techRes[2] = techRes[2].concat(
    [
      //Machineguns
      "R-Wpn-MG-Damage08", //Depleted Uranium MG Bullets
      "R-Wpn-AAGun-ROF06", //AA Chainfeed Loader Mk3
      "R-Wpn-AAGun-Damage06",//AA machine guns
      "R-Defense-Pillbox01",
      "R-Defense-RotMG",
      "R-Defense-Wall-RotMg",
      "R-Defense-WallTower-TwinAGun", //Twin Assault Gun hardpoint
      "R-Wpn-MG-Damage08", //Depleted Uranium MG Bullets
      //AA machine guns
      "R-Defense-AASite-QuadRotMg",
      "R-Vehicle-Body04", //light body bug
      "R-Vehicle-Body11", //Heavy Body - Python
      "R-Vehicle-Body09", //Heavy Body - Tiger
      "R-Sys-Sensor-Tower02", //Hardened Sensor Tower
      "R-Sys-Sensor-Upgrade03", //Sensor Upgrade Mk3
      "R-Struc-Power-Upgrade03a", //Vapor Turbine Generator Mk3
      "R-Struc-Research-Upgrade09", //Neural Synapse Research Brain Mk3
      "R-Struc-Factory-Upgrade09", //Self-Replicating Manufacturing
      "R-Struc-VTOLPad", //VTOL Rearming Pad
      "R-Vehicle-Prop-Hover",
      "R-Vehicle-Prop-Halftracks",
      "R-Vehicle-Prop-Tracks",
      "R-Defense-HardcreteGate",
      "R-Wpn-LasSat"
    ]);
  techRes[3] = techRes[3].concat(
    [
      "R-Sys-Sensor-WSTower", //Wide Spectrum Sensor Tower
      "R-Sys-Autorepair-General",
      "R-Sys-RadarDetector01", //Radar Detector
      "R-Vehicle-Armor-Heat09", //Vehicle Superdense Thermal Armor Mk3
      "R-Vehicle-Body14", // dragon body
      "R-Struc-Materials09", //Advanced Base Structure Materials Mk3 
      "R-Defense-WallUpgrade12", //Plasteel Mk3
      "R-Struc-VTOLPad-Upgrade06", //Robotic VTOL Rearming Mk3
      "R-Sys-Resistance-Circuits"  //Nexus Resistance Circuits
    ]);
  
  var resObjs = [[],[],[],[]];
  storage.techTree = [[],[],[],[]];
  
  if(storage.tankPropulsion[0] == "hover01")
  {
    techRes[0].push("R-Vehicle-Prop-Hover");
  }
  if(!storage.useTanks)
  {
    techRes[0].push("R-Vehicle-Prop-VTOL");
  }
  
  for(var a = 0; a < techRes.length; a++)
  {
    for(var b = 0; b < techRes[a].length; b++)
    {
      if(techRes[a][b][0] == "R")
      {
        resObjs[a] = resObjs[a].concat(findResearch(techRes[a][b]));
      }
      else
      {
        var n = techRes[a][b].slice(1);
        techRes[a+1].push(n);
        storage.techTree[a].push(n);
      }
    }
  }
  
  for(var a = 0; a < resObjs.length; a++)
  { 
    for(var b = 0; b < resObjs[a].length; b++)
    {
      storage.techTree[a].push(resObjs[a][b].name);
    }
  }
    
  for(var a = 0; a < storage.techTree.length; a++)
  {
    storage.techTree[a] = storage.techTree[a].filter(filter_duplicated);
    if(a > 0)
    {
      for(var b = 0; b < a; b++)
      {
        storage.techTree[a] = storage.techTree[a].filter(function (e){ return storage.techTree[b].indexOf(e) == -1; });
      }
    }
    storage.techTree[a].sort();
  }
}
//--------------------------------------------------------------------------
//Filter duplicated strings.
//--------------------------------------------------------------------------
function filter_duplicated(elem, index, self)
{ 
  return index == self.indexOf(elem);
}
//--------------------------------------------------------------------------
//  Research the tech tree when got a idle research lab.
//--------------------------------------------------------------------------
function doResearch()
{
  var labList = temp.labs.filter(function (l){ return l.status == BUILT && structureIdle(l); });
  var availableResearch = enumResearch();
  
  next:for(var a = 0; a < labList.length; a++)
  {
    for(var c = 0; c < storage.techTree.length; c++)
    {
      for(var b = 0; b < availableResearch.length; b++)
      {
        if(!(availableResearch[b].started) && availableResearch[b].power < temp.myPower && storage.techTree[c].indexOf(availableResearch[b].name) > -1)
        {
          if(pursueResearch(labList[a], availableResearch[b].name))
          {
            temp.myPower -= availableResearch[b].power;
            availableResearch.splice(b, 1);
            continue next;
          }
        }else if(storage.TaskPower < availableResearch[b].power) //Need save more power for some research
        {
          storage.TaskPower = availableResearch[b].power + 20;
        }
      }
    }
  }
  return temp.myPower < 100;  
}
//--------------------------------------------------------------------------
//Research completed, check what is available and what became deprecated.
//--------------------------------------------------------------------------
function eventResearched(research)
{
  if(!temp || !storage) //this event is called before startlevel and gameloaded.
  {
    return;
  }
  temp.tankArmory.reset();
  temp.vtolArmory.reset();
  temp.indirectDefensesArmory.reset();
  temp.ATDefensesArmory.reset();
  temp.AADefensesArmory.reset();
  temp.ArtilleryArmory.reset();
  temp.mobileArtilleryArmory.reset();
  temp.deprecated = []; //these will not be used anymore and demolished. 
  if(!temp.Weaponry)
  {
    temp.Weaponry = getWeaponry(storage.personality);
  }
  if(research == "R-Wpn-HeavyPlasmaLauncher") //Workaround for a bug that allows to make droids with PlasmaHeavy before research is done.
  {
	storage.PlasmaHeavyBug = true;
  }
  if(research == "R-Wpn-MortarEMP") //Workaround for a bug that allows to make droids with EMP Mortar before research is done.
  {
	storage.EMPMortarBug = true;
  }
  temp.tankArmory.check(temp.Weaponry.tank, true);
  temp.vtolArmory.check(temp.Weaponry.vtol, true);
  temp.indirectDefensesArmory.check(temp.Weaponry.indirect, false);
  temp.ATDefensesArmory.check(temp.Weaponry.defenses, false);
  temp.AADefensesArmory.check(temp.Weaponry.aa, false);
  temp.ArtilleryArmory.check(temp.Weaponry.artillery, false);
  temp.mobileArtilleryArmory.check(temp.Weaponry.mobileArtillery, true);
  
  //--------------------------------------------------------------------------
  if(isStructureAvailable("Emplacement-HvART-pit"))//Archangel Missile Emplacement
  {
    temp.deprecated.push("Rocket-IDF");//Ripple Rockets
  }
  if(isStructureAvailable("Emplacement-MdART-pit")) //Seraph Missile Battery
  {
    temp.deprecated.push("Rocket-MRL"); //Mini-Rocket Array
  }
  if(isStructureAvailable("Sys-SensoTowerWS")) //Wide Spectrum Sensor Tower
  {
    if(storage.WSTime == 0)
    {
      storage.WSTime = gameTime;
    }
    temp.deprecated.push("Sys-SensoTower02"); //Hardened Sensor Tower
  }
  
  if(isStructureAvailable("Wall-RotMg")) 
  {
    temp.deprecated.push("MG1Mk1");
    temp.deprecated.push("MG1-VTOL");
    temp.deprecated.push("MG2Mk1");
    temp.deprecated.push("MG2-VTOL");
    temp.deprecated.push("MG3Mk1");
    temp.deprecated.push("MG3-VTOL");
    temp.deprecated.push("MG3-Pillbox");
  }
  if(isStructureAvailable("WallTower-TwinAssaultGun")) 
  {
    temp.deprecated.push("MG1Mk1");
    temp.deprecated.push("MG1-VTOL");
    temp.deprecated.push("MG2Mk1");
    temp.deprecated.push("MG2-VTOL");
    temp.deprecated.push("MG3Mk1");
    temp.deprecated.push("MG3-VTOL");
    temp.deprecated.push("MG3-Pillbox");
  }
  if(isStructureAvailable("X-Super-Missile")) 
  {
    temp.deprecated.push("RocketSuper");
  }
  if(isStructureAvailable("Emplacement-MortarPit-Incendiary") || isStructureAvailable("Emplacement-MortarPit02")) 
  {
    temp.deprecated.push("Mortar1Mk1");
  }
  if(isStructureAvailable("Emplacement-Howitzer-Incendiary") || isStructureAvailable("Emplacement-Howitzer150")) 
  {
    temp.deprecated.push("Howitzer105Mk1");
  }
  if(isStructureAvailable("P0-AASite-SAM1")) 
  {
    temp.deprecated.push("Rocket-Sunburst");
  }
  if(isStructureAvailable("P0-AASite-SAM2")) 
  {
    temp.deprecated.push("Missile-LtSAM");
  }
  if(isStructureAvailable("Tower-Projector")) 
  {
    temp.deprecated.push("Flame1Mk1");
  }
  if(isStructureAvailable("Plasmite-flamer-bunker")) 
  {
    temp.deprecated.push("Flame2");
  }
  if(isStructureAvailable("WallTower-Rail2")) 
  {
    temp.deprecated.push("RailGun1Mk1");
  }
  if(isStructureAvailable("AASite-QuadBof02")) 
  {
    temp.deprecated.push("R-Wpn-AAGun01");
  }
  temp.deprecated = temp.deprecated.filter(filter_duplicated);
}
//--------------------------------------------------------------------------
// Returns which weaponry a personality uses.
//--------------------------------------------------------------------------
function getWeaponry(personality)
{
  const Weaponry =
  [//-------------------------------"Incendiary Cannons Artillery"
    {
      tank:
      [
        ["PlasmiteFlamer", "Flame2", "Flame1Mk1"], //Plasmite Flamer, Heavy Flamer - Inferno, Flamer
        ["Mortar-Incendiary"], //Incendiary Mortar
        ["Laser4-PlasmaCannon"], //Plasma Cannon
        ["PlasmaHeavy"], //Heavy Plasma Launcher
        ["MG5TWINROTARY", "MG4ROTARYMk1", "MG3Mk1", "MG2Mk1", "MG1Mk1"],
        ["HeavyLaser"], //Heavy Laser
        ["Laser2PULSEMk1", "Laser3BEAMMk1"] //Pulse Laser, Laser - Flashlight
      ],
      aa:
      [
        ["AASite-QuadRotMg", "AASite-QuadMg1"], //whirlwind, hurricane
        ["P0-AASite-Laser"] //Stormbringer Emplacement
      ],
      vtol:
      [
        ["Bomb4-VTOL-HvyINC", "Bomb3-VTOL-LtINC"], //Thermite Bomb Bay, Phosphor Bomb Bay
        ["Bomb5-VTOL-Plasmite"], //Plasmite Bomb
        ["Laser2PULSE-VTOL", "Laser3BEAM-VTOL"], //Pulse Laser, Laser - Flashlight
        ["MG4ROTARY-VTOL", "MG3-VTOL", "MG2-VTOL"],
        ["HeavyLaser-VTOL"] //Heavy Laser
      ],indirect:
      [
        ["Emplacement-HeavyPlasmaLauncher"],
        ["Emplacement-MortarPit-Incendiary"] //Incendiary Mortar Pit
      ],
      defenses:
      [
        ["WallTower-TwinAssaultGun", "Wall-RotMg", "WallTower01"],
        ["Pillbox-RotMG", "PillBox1", "GuardTower1"],
        ["Emplacement-HeavyLaser"], //Heavy Laser Emplacement
        ["Emplacement-PlasmaCannon"],
        ["WallTower-PulseLas", "Emplacement-PrisLas"], //Pulse Laser Hardpoint, Flashlight Emplacement
        ["GuardTower-BeamLas"],
        ["Plasmite-flamer-bunker", "Tower-Projector", "PillBox5"]
      ],
      artillery:
      [
        ["Emplacement-Howitzer-Incendiary"]  //Incendiary Howitzer Emplacement
      ],
      mobileArtillery:
      [
        ["Howitzer-Incendiary"] //Incendiary Howitzer
      ]
    },
    {  //-------------------------------"Cannons Artillery"
      tank:
      [
        ["Cannon2A-TMk1", "Cannon1Mk1"], //Medium Cannon, Light Cannon
        ["Cannon375mmMk1"],    //Heavy Cannon
        ["Cannon4AUTOMk1"],  //Hyper Velocity Cannon
        ["Cannon6TwinAslt", "Cannon5VulcanMk1"],
        ["Mortar2Mk1"], //Heavy Mortar - Bombard, Mortar
        ["Mortar3ROTARYMk1"], //Rotary Mortar - Pepperpot
        ["RailGun3Mk1"], //Gauss Cannon
        ["RailGun2Mk1", "RailGun1Mk1"], //Rail Gun, Needle Gun
        ["MG5TWINROTARY", "MG4ROTARYMk1", "MG3Mk1", "MG2Mk1", "MG1Mk1"]
      ],
      aa:
      [
        ["AASite-QuadRotMg", "AASite-QuadMg1"], //whilwind, hurricane
        ["AASite-QuadBof02", "AASite-QuadBof"]  //AA Tornado Flak Cannon Emplacement, AA Cyclone Flak Cannon Emplacement
      ],
      vtol:
      [
        ["Bomb2-VTOL-HvHE", "Bomb1-VTOL-LtHE"], //HEAP Bomb Bay, Cluster Bomb Bay
        ["Cannon4AUTO-VTOL"],
        ["MG4ROTARY-VTOL", "MG3-VTOL", "MG2-VTOL"],
        ["RailGun2-VTOL", "RailGun1-VTOL"] //Rail Gun, Needle Gun
      ],
      indirect:
      [
        ["Emplacement-MortarPit02", "Emplacement-MortarPit01"], //Bombard Pit, Mortar Pit
        ["Emplacement-RotMor"] //Pepperpot Pit 
      ],
      defenses:
      [
        ["X-Super-Cannon"], //Cannon Fortress
        ["X-Super-MassDriver"], //Mass Driver Fortress
        ["WallTower04"], //Heavy Cannon Hardpoint
        ["WallTower-HPVcannon"], //Hyper Velocity Cannon Hardpoint
        ["WallTower03", "WallTower02", "PillBox4"], //Medium Cannon Hardpoint, Light Cannon Hardpoint, Light Cannon Bunker 
        ["WallTower-Rail3", "WallTower-Rail2", "GuardTower1"], //Gauss Cannon Hardpoint, Rail Gun Hardpoint, Needle Gun Tower 
        ["WallTower-TwinAssaultGun", "Wall-RotMg", "WallTower01"],
        ["Pillbox-RotMG", "PillBox1", "GuardTower1"]
      ],
      artillery:
      [
        ["Emplacement-Howitzer150", "Emplacement-Howitzer105"], //Ground Shaker Emplacement, Howitzer Emplacement
        ["Emplacement-RotHow"] //Hellstorm Emplacement
      ],
      mobileArtillery:
      [
        ["Howitzer150Mk1", "Howitzer105Mk1"], // Heavy Howitzer - Ground Shaker, Howitzer, "Mortar2Mk1", "Mortar1Mk1"
        ["Howitzer03-Rot"] //Rotary Howitzer - Hellstorm
      ]
    },
    {//-------------------------------"Missiles Artillery" 
      tank:
      [
        ["Rocket-Pod"], //Mini-Rocket Pod
        ["Missile-A-T"],  //Scourge Missile
        ["MG5TWINROTARY", "MG4ROTARYMk1", "MG3Mk1", "MG2Mk1", "MG1Mk1"],
        ["Rocket-HvyA-T", "Rocket-LtA-T"],  //Tank Killer, Lancer
        ["Missile-MdArt", "Rocket-MRL"] //Seraph Missile Array, Mini-Rocket Array
      ],
      aa:
      [
        ["AASite-QuadRotMg", "AASite-QuadMg1"], //whirlwind, hurricane
        ["P0-AASite-SAM2", "P0-AASite-SAM1", "P0-AASite-Sunburst"] //Vindicator SAM Site, Avenger SAM Site, Sunburst AA Site
      ],
      vtol:
      [
        ["Missile-VTOL-AT"], //Scourge Missile
        ["Rocket-VTOL-HvyA-T", "Rocket-VTOL-LtA-T"], //Tank Killer, Lancer
        ["MG4ROTARY-VTOL", "MG3-VTOL", "MG2-VTOL"]
      ],
      indirect:
      [
        ["Emplacement-MdART-pit", "Emplacement-MRL-pit"] //Seraph Missile Battery, Mini-Rocket Battery
      ],
      defenses:
      [
        ["GuardTower6"], //Mini-Rocket Tower
        ["WallTower-HvATrocket", "WallTower06"], //Tank Killer Hardpoint, Lancer Hardpoint
        ["WallTower-Atmiss", "WallTower-TwinAssaultGun", "Wall-RotMg", "WallTower01", "GuardTower1"], //Scourge Missile Hardpoint
        ["X-Super-Missile", "X-Super-Rocket"]  // Missile Fortress, Heavy Rocket Bastion 
      ],
      artillery:
      [
        ["Emplacement-HvART-pit", "Emplacement-Rocket06-IDF"] //Archangel Missile Emplacement, Ripple Rocket Battery
      ],
      mobileArtillery:
      [
        ["Missile-HvyArt", "Rocket-IDF"] //, "Missile-MdArt", "Rocket-MRL"Archangel Missile, Ripple Rocket, Seraph Missile Array Mini-Rocket Array
      ]
    }
  ];
  return Weaponry[personality];
}
//--------------------------------------------------------------------------
// Returns which tech tree a personality uses.
//--------------------------------------------------------------------------
function getTechTree(personality)
{
  const tech =
  [//--------------------------------"Incendiary Cannons Artillery"-----------------
    [
      [
        "+R-Wpn-Mortar02Hvy",
        "+R-Wpn-Mortar-Incendiary",
        //Howitzers
        "+R-Wpn-HowitzerMk1",
        "+R-Wpn-Howitzer-Incendiary"
      ],
      [
        "R-Defense-MortarPit-Incendiary", //Incendiary Mortar Pit
        "R-Defense-Howitzer-Incendiary", //Emplacement-Howitzer-Incendiary
        "R-Defense-HeavyPlasmaLauncher" //Heavy Plasma Launcher Emplacement
      ],
      [
        //VTOL Incendiary bombs
        "R-Wpn-Bomb04", //Thermite Bomb Bay
        "R-Defense-Pillbox05", //Flamer Bunker
        "R-Defense-HvyFlamer", //Inferno Bunker
        "R-Defense-PlasmiteFlamer", //Plasmite Flamer Bunker
        "R-Defense-PlasmaCannon", //Plasma Cannon Emplacement
        "R-Defense-PulseLas",
        "R-Wpn-Flamer-Damage06", //Superhot Flamer Gel Mk3
        "R-Wpn-Flamer-ROF03", //Flamer Autoloader Mk3
        "R-Wpn-Flame2", //Heavy Flamer - Inferno
        "R-Wpn-Mortar-Acc03", //Target Acquisition Mortar Shells
        "R-Wpn-Mortar-Damage06", //HEAP Mortar Shells Mk3
        "R-Wpn-Mortar-ROF04", //Mortar Fast Loader
        "R-Wpn-Howitzer-Accuracy03", //Target Prediction Artillery Shells
        "R-Wpn-Howitzer-Damage03", //HE Howitzer Shells Mk3
        "R-Wpn-Howitzer-ROF04" //Howitzer Fast Loader
      ],
      [
        //VTOL Incendiary bombs
        "R-Wpn-Bomb05",  //Plasmite Bomb
        "R-Wpn-Flamer-Damage09", //Superhot Plasmite gel Mk3
        "R-Wpn-Plasmite-Flamer", //Plasmite flamer
        "R-Wpn-PlasmaCannon", //Plasma Cannon
        "R-Wpn-Howitzer-Damage06", //HEAP Howitzer Shells Mk3
        //"R-Defense-Super-Cannon", //Cannon Fortress
        //Lasers
        "R-Wpn-Energy-ROF03", // Thermopole Energizer Mk3
        "R-Wpn-Energy-Accuracy01", //Improved Laser Focusing
        "R-Wpn-Energy-Damage03", //Hi-Energy Laser Emitter Mk3
        "R-Defense-PrisLas", //Flashlight Emplacement
        "R-Defense-WallTower-PulseLas", //Pulse Laser Hardpoint
        "R-Defense-HeavyLas", //Heavy Laser Emplacement
        "R-Defense-AA-Laser" //Stormbringer Emplacement
      ]
    ],
    //--------------------------------Cannons Artillery tech tree--------------------
    [
      [
        "+R-Wpn-Mortar02Hvy", 
        "+R-Wpn-HowitzerMk1",
        "+R-Wpn-HvyHowitzer"
      ],
      [
        "R-Defense-MortarPit", //Mortar Pit
        "R-Defense-HvyMor", //Bombard Pit
        "R-Defense-Howitzer", //Howitzer Emplacement
        "R-Defense-HvyHowitzer" //Ground Shaker Emplacement
      ],
      [
        "R-Defense-AASite-QuadBof", //AA Cyclone Flak Cannon Emplacement
        "R-Defense-AASite-QuadBof02", //AA Tornado Flak Cannon Emplacement
        "R-Wpn-Bomb02", //HEAP Bomb Bay
        "R-Wpn-Bomb-Damage03", //Advanced Bomb Warhead
        "R-Wpn-Cannon-Accuracy02", //Cannon Laser Designator
        "R-Wpn-Cannon-Damage09", //HVAPFSDS Cannon Rounds Mk3
        "R-Wpn-Cannon-ROF06", //Cannon Rapid Loader Mk3
        "R-Wpn-Mortar-Acc03", //Target Acquisition Mortar Shells
        "R-Wpn-Mortar-Damage06", //HEAP Mortar Shells Mk3
        "R-Wpn-Mortar-ROF04", //Mortar Fast Loader
        "R-Defense-WallTower03", //Medium Cannon Hardpoint
        "R-Defense-WallTower02", //Light Cannon Hardpoint
        "R-Defense-WallTower-HPVcannon", //Hyper Velocity Cannon Hardpoint
        "R-Wpn-Howitzer-Accuracy03", //Target Prediction Artillery Shells
        "R-Wpn-Howitzer-Damage03", //HE Howitzer Shells Mk3
        "R-Wpn-Howitzer-ROF04", //Howitzer Fast Loader
        "R-Wpn-AAGun-Accuracy03" //AA Target Prediction Computer
      ],
      [
        "R-Defense-RotMor", //Pepperpot Pit
        "R-Defense-RotHow", //Hellstorm Emplacement
        "R-Wpn-Howitzer-Damage06", //HEAP Howitzer Shells Mk3
        "R-Defense-WallTower04", //Heavy Cannon Hardpoint
        "R-Defense-GuardTower-Rail1", //Needle Gun Tower
        "R-Defense-WallTower-Rail2", //Rail Gun Hardpoint
        "R-Defense-WallTower-Rail3", //Gauss Cannon Hardpoint
        "R-Wpn-Cannon6TwinAslt", //Twin Assault Cannon
        "R-Wpn-Rail-ROF03", //Rail Gun ROF Mk3
        "R-Wpn-Rail-Accuracy01", //Rail Target Prediction Computer
        "R-Wpn-Rail-Damage03",  //Hardened Rail Dart Mk3
        "R-Defense-Super-Cannon", //Cannon Fortress
        "R-Defense-MassDriver" //Mass Driver Fortress
      ]
    ],  
    //--------------------------------Rockets Artillery tech tree--------------------
    [
      [
        "+R-Wpn-Rocket05-MiniPod",
        "+R-Wpn-Rocket-Damage01", 
        "+R-Wpn-Rocket-Damage02", 
        "+R-Wpn-Rocket-Damage03",
        "+R-Wpn-Mortar-Acc01",
        "+R-Wpn-Rocket02-MRL",
        "+R-Wpn-Rocket06-IDF"
      ],
      [
        "R-Defense-MRL", //Mini-Rocket Battery
        "R-Defense-IDFRocket" //Ripple Rocket Battery
      ],
      [
        "R-Wpn-RocketSlow-Accuracy02", //Thermal Imaging Rockets
        "R-Wpn-Rocket-Damage09", //HESH Rocket Warhead Mk3
        "R-Wpn-Rocket-ROF03",//Rocket Autoloader Mk3
        "R-Defense-Tower06", // mini-rocket tower
        "R-Defense-WallTower06", //Lancer Hardpoint
        "R-Defense-WallTower-HvyA-Trocket", //Tank Killer Hardpoint
        //AA rockets
        "R-Defense-Sunburst" //Sunburst AA Site
       ],
       [
         //Missile Artillery
         "R-Defense-MdArtMissile", //Seraph Missile Battery
         "R-Defense-HvyArtMissile", //Archangel Missile Battery
         //AA missiles
         "R-Defense-SamSite1", //Avenger SAM Site
         "R-Defense-SamSite2", //Vindicator SAM Site
         "R-Wpn-Missile-Accuracy02", //Search & Destroy Missiles
         "R-Wpn-Missile-Damage03", //Advanced Missile Warhead Mk3
         "R-Wpn-Missile-ROF03", //Advanced Missile Allocation System Mk3
         "R-Defense-WallTower-A-Tmiss", //Scourge Missile Hardpoint
         "R-Defense-Super-Rocket", //Heavy Rocket Bastion
         "R-Defense-Super-Missile" // Missile Fortress
       ]
    ]
  ]; 
  return tech[personality];
}
