//--------------------------------------------------------------------------
//Makes and commands fight, sensor and artillery vehicles.
//--------------------------------------------------------------------------
function Squad()
{
  this.max;
  this.min = 0;
}
//-------------------------------------------------------------------------- 
//Return fire to someone that attack you while you were moving to attack (tank) or observe (sensor) someone else.
//-------------------------------------------------------------------------- 
function eventAttacked(victim, attacker){
  if(victim && attacker && victim.player == me)
  {
    if(!victim.isVTOL && !attacker.isVTOL && !allianceExistsBetween(victim.player, attacker.player) && attacker.player != me)
    {
      if(victim.type == DROID && (victim.order == DORDER_ATTACK || victim.order == DORDER_OBSERVE))
      {
        orderDroid(victim, DORDER_STOP);
      }
      if(storage.sensors.leader && victim.id == storage.sensors.leader.id)
      {
        storage.sensors.target = undefined;
      }
      if(!storage.offensive && (gameTime - storage.beaconSent) > 180000) //3minutes
      {
        storage.beaconSent = gameTime;
        addBeacon(attacker.x, attacker.y, ALLIES, "Help! please!");  //Call help.
      }
    }
  }
}
//-------------------------------------------------------------------------- 
// Responds beacons calling help.
//--------------------------------------------------------------------------
function eventBeacon(x, y, sender, to, message)
{
  if(allianceExistsBetween(me, sender) && me != sender)
  {
    storage.beaconReceived.time = gameTime;
    storage.beaconReceived.x = x;
    storage.beaconReceived.y = y;
    if(storage.offensive)
    {
      chat(sender, "I will help! Hold on!");
      BFSnapShot();
      temp.tanks.forEach(function (d){ if(d.order == DORDER_ATTACK){ orderDroid(d, DORDER_STOP); } }); //Next warTactic() cycle will send them to help.
    }
    else
    {
      chat(sender, "Sorry! Can't do it now! But I will try if possible.");
    }
  }
}
//-------------------------------------------------------------------------- 
// Moves tanks, mobile sensors, mobile artillery and VTOLs.
//--------------------------------------------------------------------------
function warTactic()
{  
  var enemies = findEnemies();
  if(enemies && enemies.length > 0)//Got ground enemies.
  {
    var validBeacon = (gameTime - storage.beaconReceived.time) < 120000;//2min. Got valid beacon, go help a friend.
    var attackDroids = temp.alldroids.length - temp.trucks.length;
    if(storage.offensive || enemies.filter(function (e){ return distBetweenTwoPoints(e.x, e.y, startPositions[me].x, startPositions[me].y) < storage.baseRange; }).length > 2)//Check if it is time to retreat or keep pushing.
    { 
      if(attackDroids < Math.ceil(storage.droidsAttackMin*temp.lossTolerance))
      {
        storage.offensive = false;
        storage.droidsAttackMin += Math.ceil(storage.droidsBaseLimit*0.06);
        if(storage.droidsAttackMin > Math.ceil(storage.droidsBaseLimit*temp.lossTolerance))
        {
          storage.droidsAttackMin = Math.ceil(storage.droidsBaseLimit*temp.lossTolerance);
        }
      }
    }
    else
    {
      storage.offensive = (temp.tanks.length >= storage.tanks.min) && attackDroids > storage.droidsAttackMin;//enough tanks to be offensive.
    }
    //VTOLs
    if(temp.vtols.length > 0)//Have VTOLs.
    { 
      //rearm idle unarmed vtols.
      var rearm = temp.vtols.filter(function(d){return d.weapons[0].armed < 100 && d.action == 0; });
      if(rearm.length > 0)
      {
        for(var a = 0; a < rearm.length; a++)
        {
          orderDroid(rearm[a], DORDER_REARM);
        }
      }
      var vtolsArmed = temp.vtols.filter(function(d){ if(d.weapons[0].armed > 0){  return (d.order == DORDER_ATTACK && d.action == 0) || d.order == 0 || d.action == 34; } return false;}); //VTOLs ready for strike wave or still can fire but are heading home or buged with DORDER_ATTACK but no action.
      if(vtolsArmed.length > 0) 
      {
        if(!(storage.offensive && validBeacon && pickTargets(vtolsArmed, enemies, storage.beaconReceived.x, storage.beaconReceived.y, storage.baseRange) != 0))
        {
          pickTargets(vtolsArmed, enemies);
        }
      }
    }//End Vtols
    
    //Ground
    var tanks = temp.tanks.filter(filter_notAttacking); //tanks not attacking.
    if(storage.offensive) 
    { 
      //Tanks
      if(tanks.length > 0)
      {
        if(!(validBeacon && pickTargets(tanks, enemies, storage.beaconReceived.x, storage.beaconReceived.y, storage.baseRange) != 0)) //No targets at beacon location! or no beacon.
        {
          pickTargets(tanks, enemies);//Tanks! Shoot everything!
        }
      }
      //Sensors
      if(temp.sensors.length > 0)  //Have sensors
      {
        if(temp.mobartillery.length > 0 || temp.indirect.length > 0)
        {
          if(temp.sensors.length > 0)
          {
            if(!(validBeacon && pickTargets(temp.sensors, enemies, storage.beaconReceived.x, storage.beaconReceived.y, storage.baseRange) != 0)) //No targets at beacon location! or no beacon.
            {
              pickTargets(temp.sensors, enemies);
            }
          }
        }
        else
        { //no artillery
          retreat(temp.sensors, 0.5);
          storage.sensors.target = undefined;
        }
      }
      else
      { //No sensors
        storage.sensors.target = undefined;
      }// end sensors
      //Artillery
      if(temp.mobartillery.length > 0) 
      {
        if(storage.sensors.target)
        {
          MoveToRange(temp.mobartillery, storage.sensors.target);//Move mobile artillery
        }
        else
        {
          retreat(temp.mobartillery, 0.3); //These droid are not suited for a fight.
        }
      }
      //end Mobile artillery
      //Indirect fire tanks
      if(temp.indirect.length > 0) 
      {
        if(storage.sensors.target)
        {
          MoveToRange(temp.indirect, storage.sensors.target);
        }
        else
        {
          var indirect = temp.indirect.filter(filter_notAttacking); //not attacking a target.
          if(indirect.length > 0)
          {
            pickTargets(indirect, enemies);
          }
        }
      }
    }
    else
    {//outnumbered
      var safe = retreat(temp.tanks, 0.9); //Keep tanks defending around the base
      safe = safe.filter(filter_notAttacking);
      if(safe.length > 0)
      {
        pickTargets(safe, enemies, startPositions[me].x, startPositions[me].y, storage.baseRange); //Defend the base.  
      }
      var safe = retreat(temp.sensors, 0.7); //Keep sensors behind the tanks
      safe = safe.filter(function filter_notAttacking(d){ return d.order != DORDER_ATTACK; });
      if(safe.length > 0)
      {
        pickTargets(safe, enemies, startPositions[me].x, startPositions[me].y, storage.baseRange);
      }
      var safe = retreat(temp.mobartillery, 0.3); //keep artillery near center.
      if(safe.length > 0)
      {
        if(storage.sensors.target)
        {
          MoveToRange(safe, storage.sensors.target);//Move mobile artillery
        }
      }
      var safe = retreat(temp.indirect, 0.5); //keep indirect near center.
      if(safe.length > 0)
      {
        if(storage.sensors.target)
        {
          MoveToRange(safe, storage.sensors.target);
        }
        else
        {
          pickTargets(safe, enemies, startPositions[me].x, startPositions[me].y, storage.baseRange);
        }
      }
      //request resources
      if(storage.chatOn && (gameTime - storage.lastRequest) > 120000)//2min
      {
        if(temp.myPower < storage.TaskPower)
        {
          chat(ALLIES, "need power");
          storage.lastRequest = gameTime;
        }
        if(temp.trucks.length < 2)
        {
          chat(ALLIES, "need trucks");
          storage.lastRequest = gameTime;
        }
        if(temp.tanks.length < Math.ceil(storage.tanks.min*0.5))
        {
          chat(ALLIES, "need tanks");
          storage.lastRequest = gameTime;
        }
      }
    }
  }
}
//--------------------------------------------------------------------------
// Filter tanks that are not attacking somenone
//--------------------------------------------------------------------------
function filter_notAttacking(d)
{
  return d.order != DORDER_ATTACK; 
}
//--------------------------------------------------------------------------
// Each one attack the nearest enemy target. If X, Y and range are specified attack enemies in this range from X and Y only. If units are sensors all targets the same enemy.
//--------------------------------------------------------------------------
function pickTargets(units, enemies, X, Y, range)
{
  var fenemies;
  if(range && X && Y && range > 0)  //Filter enemies in specified range
  {
    fenemies = enemies.filter(function(e){ return (distBetweenTwoPoints(X, Y, e.x, e.y) <= range); });
  }
  else //Attack everyone
  {
    fenemies = enemies;
  }
  if(fenemies.length > 0)
  {
    if(units[0].isSensor)
    {
      storage.sensors.leader = units.filter(function (s){ return storage.sensors.leader && s.id == storage.sensors.leader.id; })[0];
      if(!storage.sensors.leader)
      {
        storage.sensors.leader = units[0];
      }
      storage.sensors.target = fenemies.filter(function (e){ return storage.sensors.target && e.id == storage.sensors.target.id; })[0];
      if(!storage.sensors.target)
      {
        storage.sensors.target = fenemies[indexOfNearest(fenemies, storage.sensors.leader.x, storage.sensors.leader.y)];
      }
      units.forEach(function (s){ if(s.order != DORDER_OBSERVE || s.id != storage.sensors.leader.id){ orderDroidObj(s, DORDER_OBSERVE, storage.sensors.target); }});// All sensor aim at same enemy
    }
    else
    {
      for(var a = 0; a < units.length; a++)//each one attack the nearest enemy target
      {
        var nearest = indexOfNearest(fenemies, units[a].x, units[a].y); //pick the nearest one an attack.
        orderDroidObj(units[a], DORDER_ATTACK, fenemies[nearest]);
      }
    }
  }
  return fenemies.length;
}
//--------------------------------------------------------------------------
// Moves artillery
//--------------------------------------------------------------------------
function MoveToRange(units, target)
{
  for(var a = 0; a < units.length; a++)
  {
    var distance = distBetweenTwoPoints(units[a].x, units[a].y, target.x, target.y);
    var range = units[a].range/128 - 2; //Range in tiles
    if(distance > range) //If target is out of range, move to reduce it.
    {
      var pos = getCloser(units[a], target, range, distance);
      if(pos)
      {
        if(units[a].range > temp.artilleryRange)
        {
          orderDroidLoc(units[a], DORDER_MOVE, pos.x, pos.y); 
        }
        else if(units[a].order != DORDER_MOVE)
        {
          orderDroidLoc(units[a], DORDER_MOVE, pos.x, pos.y);
        }
      }
    }
    else if(distance < (Math.ceil(range*0.6))) //Too exposed. Move away.
    {
      var pos = goAway(units[a], target, Math.ceil(range*0.8), distance);
      if(pos)
      {
        if(units[a].range > temp.artilleryRange)
        {
          orderDroidLoc(units[a], DORDER_MOVE, pos.x, pos.y); 
        }
        else if(units[a].order != DORDER_MOVE)
        {
          orderDroidLoc(units[a], DORDER_MOVE, pos.x, pos.y);
        }
      }
    }
    else if(units[a].action == 1 || units[a].action == 23) //Target is in range, stop were you are.
    {
      orderDroid(units[a], DORDER_STOP);
    }
  }
}
//--------------------------------------------------------------------------
// Moves closer to a point. Distance was calculated already.
//--------------------------------------------------------------------------
function getCloser(unit, target, range, distance)
{
  var dx = target.x - unit.x;
  var dy = target.y - unit.y;
  var sin = dy/distance;
  var cos = dx/distance;
  var pos = { x: Math.round(range*cos) + unit.x, y: Math.round(range*sin) + unit.y };
  if(pos.x < 4 || pos.x > temp.boundWidth || pos.y < 4 || pos.y > temp.boundHeight )
  {
    return undefined;  //Invalid coordinates
  }
  return pos;
}
//--------------------------------------------------------------------------
// Moves away from a point. Distance was calculated already.
//--------------------------------------------------------------------------
function goAway(unit, target, range, distance)
{
  var dx = target.x - unit.x;
  var dy = target.y - unit.y;
  var sin = dy/distance;
  var cos = dx/distance;
  var pos = { x: unit.x - Math.round(range*cos), y: unit.y - Math.round(range*sin) };
  if(pos.x < 4 || pos.x > temp.boundWidth || pos.y < 4 || pos.y > temp.boundHeight)
  {
    return undefined;  //Invalid coordinates
  }
  return pos;
}
//--------------------------------------------------------------------------
// Retreat to base. Returns an array with who is inside base range. u = [droids], d = % distance factor
//--------------------------------------------------------------------------
function retreat(u, d)
{
  var safe = [];
  var sqRange = Math.floor(storage.baseRange*Math.sin(45));
  var range = Math.floor(sqRange*d);
  var csqX = Math.round(startPositions[me].x - range/2);
  var csqY = Math.round(startPositions[me].y - range/2);
  
  if(csqX < 4)
  {
    csqX = 4;
  }
  if(csqY < 4)
  {
    csqY = 4;
  }

  if(u.length > 0)
  {
    for(var a = 0; a < u.length; a++)
    {
      if(distBetweenTwoPoints(u[a].x, u[a].y, startPositions[me].x, startPositions[me].y) > storage.baseRange)
      {
        var x = csqX + Math.round(Math.random()*range);
        var y = csqY + Math.round(Math.random()*range);
        orderDroidLoc(u[a], DORDER_MOVE, (x > temp.boundWidth)? temp.boundWidth: x, (y > temp.boundHeight)? temp.boundHeight: y);
      }
      else
      {
        safe.push(u[a]);
      }
    }
  }
  return safe;
}
//--------------------------------------------------------------------------
// All enemies
//--------------------------------------------------------------------------
function allEnemies()
{
  return enumRange(Math.round(mapWidth/2), Math.round(mapHeight/2), (mapWidth > mapHeight)? mapWidth : mapHeight, ENEMIES, false);
}
//--------------------------------------------------------------------------
// Finds all visible enemies or one invisible nearest from base
//--------------------------------------------------------------------------
function findEnemies()
{
  var enemies = allEnemies();
  if(enemies && enemies.length > 0)
  {
    return enemies.filter(function (e){ if(e.type == DROID && e.isVTOL){ return (e.order != DORDER_ATTACK && e.action != 23 && e.action != 24 && e.action != 34 && e.action != 36 && e.action != 38 && e.action != 41);} return true; }); //do not attack flying vtols or a endless dogfight will happen.
  }  
}
//--------------------------------------------------------------------------
// Use laser satellite
//--------------------------------------------------------------------------
function eventStructureReady(structure) //Shoot the laser where are more crowded enemies.
{
  if(structure.stattype == LASSAT)
  {
    var enemies = allEnemies();
    if(enemies && enemies.length > 0)
    {
      var target = 0;
      var max = 0;
      for(var a = 0; a < enemies.length; a++)
      {
        var p = enumRange(enemies[a].x, enemies[a].y, 3, ENEMIES, false);
        if(p && p.length > max)
        {
          max = p.length;
          target = a;
        }
      }
      activateStructure(structure, enemies[target]);
    }
  }
}
